/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : 
*/
/*************************************************************************/
/*************************************************************************/

#include "trapMF.h"
#include "XtrapMF.h"
#include "Function.h"
#include "../deffunc.h"
#include <iostream.h>

trapMF::trapMF(float _l, float _IT, float _rT, float _r)
{  float k[4], va;
   int i,j;

   k[0] = _l; k[1]=_IT; k[2]=_rT; k[3]=_r;

   for(i=0;i<3;i++)
    for(j=i+1;j<4;j++)
      if(k[i]>k[j]) 
      {  va = k[i];
	 k[i] = k[j];
	 k[j] = va;
      }// end of if
  
   Left = k[0];
   LeftTop = k[1];
   RightTop = k[2];
   Right = k[3];
   cutOff = 1.0;

}// end of constructor

trapMF::setLeftBorder(float _newValue) 
{ int ok=1;
  if(_newValue>LeftTop) ok=0;
  else Left = _newValue; 
  return ok;
}// end of setLeftBorder()

trapMF::setLeftTop(float _newValue) 
{ int ok=1;
  if(_newValue<Left || _newValue>RightTop) ok=0;
  else LeftTop = _newValue; 
  return ok;
}// end of setLeftTop()

trapMF::setRightTop(float _newValue) 
{ int ok=1;
  if(_newValue>Right || _newValue<LeftTop) ok=0;
  else RightTop = _newValue; 
  return ok;
}// end of setRightTop()

trapMF::setRightBorder(float _newValue) 
{ int ok=1;
  if(_newValue<RightTop) ok=0;
  else Right= _newValue ; 
  return ok;
}// end of setRightBorder()

float trapMF::getLeftBorder() const { return Left; }

float trapMF::getLeftTop() const { return LeftTop; }

float trapMF::getRightTop() const { return RightTop; }

float trapMF::getRightBorder() const { return Right; }

float trapMF::getValue(float x) 
{ float ret; 
  ret=maximum(minimum(minimum((x-Left)/(LeftTop-Left),1),(Right-x)/(Right-RightTop)),0); 
  return minimum(ret,cutOff);
}// end of getValue()

Function *trapMF::Xversion()
{  XtrapMF *ret = new XtrapMF(Left,LeftTop,RightTop,Right);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of Xversion()

Function *trapMF::getMyTwin()
{  trapMF *ret = new trapMF(Left,LeftTop,RightTop,Right);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of getMyTwin()

ostream& operator<<(ostream& os, const trapMF& RHS)
{  os << " Trapezoid("<<RHS.Left<<","<<RHS.LeftTop;
   os << "," << RHS.Right << "," << RHS.RightTop << ") with " <<RHS.cutOff;
   return os;
}// end of operator<<

void trapMF::printOn(ostream& os) const {  os<<(*this); }


